## libcds-pubsub 0.3.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}")
include(pub_sub_version)
set (PROJECT_SHORT_NAME cds-pubsub)
get_pub_sub_version(PUB_SUB_PROJECT_VERSION_STR)
get_pub_sub_version_tag(PUB_SUB_PROJECT_VERSION_TAG)
project(lib${PROJECT_SHORT_NAME} VERSION ${PUB_SUB_PROJECT_VERSION_STR})

get_debian_version(deb_ver)
message(STATUS "Project version = ${PUB_SUB_PROJECT_VERSION_STR}${PUB_SUB_PROJECT_VERSION_TAG}" )
message(STATUS "Debian  version = ${deb_ver}")
if (NOT "${deb_ver}" STREQUAL "${PUB_SUB_PROJECT_VERSION_STR}${PUB_SUB_PROJECT_VERSION_TAG}")
    MESSAGE(FATAL_ERROR "The debian package version is out of sync with the project version")
endif()



set(CMAKE_CXX_STANDARD 14)

enable_testing()

include(CMakePackageConfigHelpers)

find_package(Boost REQUIRED system)
find_package(pybind11 REQUIRED)
find_package(Threads)
include(FindZStd)

install(FILES COPYING README.md
        DESTINATION share/doc/${CMAKE_PROJECT_NAME}
        PERMISSIONS OWNER_READ GROUP_READ WORLD_READ )

add_subdirectory(external)
add_subdirectory(pub_sub)
add_subdirectory(python)
add_subdirectory(examples)
