=== examples/CMakeLists.txt ===
add_executable(publisher publisher.cc)
target_link_libraries(publisher PUBLIC pub_sub_asan)

add_executable(subscriber subscriber.cc)
target_link_libraries(subscriber PUBLIC pub_sub_asan)

# the main examples are built with sanitizer support
# do a build to make sure it can build w/o sanitizers
add_executable(publisher_nosan publisher.cc)
target_link_libraries(publisher_nosan PUBLIC pub_sub)
