=== python/CMakeLists.txt ===
pybind11_add_module(pubsub pub_sub_python.cc)
target_link_libraries(pubsub PRIVATE pub_sub)

install(TARGETS pubsub
        LIBRARY DESTINATION lib/python3/dist-packages
        ARCHIVE DESTINATION lib/python3/dist-packages
        )
