=== debian/changelog ===
libcds-pubsub (0.3.2) unstable; urgency=medium

  * Changes to build under Debian bullseye and buster

 -- Jonathan Hanks <jhanks@caltech.edu>  Tue, 17 Aug 2021 21:07:57 -0700

libcds-pubsub (0.3.1) unstable; urgency=medium

  * Updates to the cmake dependencies

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Mon, 02 Aug 2021 17:31:35 -0700

libcds-pubsub (0.3.0) unstable; urgency=medium

  * Added support for setting up pipelines of pub/sub objects.
  * Added a compression pub/sub mechanism based around zstd. 

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Mon, 02 Aug 2021 14:04:58 -0700

libcds-pubsub (0.2.0) unstable; urgency=medium

  * Adding support for restarting subscriptions (this only works on tcp).

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Thu, 08 Oct 2020 09:54:11 -0700

libcds-pubsub (0.1.0) unstable; urgency=medium

  * Added a plugin interface for publishers and subscribers. 

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Sat, 11 Apr 2020 08:59:21 -0700

libcds-pubsub (0.0.0) unstable; urgency=medium

  * Initial Release.

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Wed, 04 Mar 2020 13:03:52 -0800
